int SingleEndIndelVerifier::Thanh_Align(int allowed_errors, char * sref, char *sread, int reflen, int redlen, int z)
{
    // load up the indices
    for (t_g=-allowed_errors;t_g<=allowed_errors;t_g++)
    {
        t_index = allowed_errors+t_g;
        t_max = z+t_g;
        t_U[t_index] = 0;
        for (t_i=0;t_i<t_max;t_i++)
        {
            t_U[t_index] += 1;
            t_U[t_index] = t_U[t_index] << 1;
        }
        for (t_i=0;t_i<redlen;t_i++)
        {
            if (t_i+t_max < reflen)
                t_U[t_index] += (sread[t_i]^sref[t_i+t_max]?1:0);
            else t_U[t_index] += 1;
            t_U[t_index] = t_U[t_index] << 1;
        }
        t_U[t_index] = t_U[t_index] >> 1;
        t_D[allowed_errors][t_index] = t_U[t_index];
    }

    // here comes the algorithm
    for(t_k=0; t_k<allowed_errors; t_k++)
    {
        for(t_g=-allowed_errors; t_g<=allowed_errors;t_g++)
        {
            t_index = allowed_errors+t_g;
            t_max = allowed_errors+t_k;
            t_v = t_D[t_max][t_index] & (t_D[t_max][t_index]-1);
            if (!t_v)
                return t_k;
            if (t_g < 0) // deletion
            {
                t_m = t_D[t_max][t_index-1]^t_D[t_max][t_index-1];
                t_vp = t_m&t_U[t_index];
                if ((t_vp & -t_vp) > (t_v & -t_v))
                    t_v = t_vp;
            }
            if (t_g > 0)
            {
                t_m = t_D[t_max][t_index+1]|-t_D[t_max][t_index+1];
                t_vp = t_m&t_U[t_index];
                if ((t_vp & -t_vp) >  (t_v & -t_v))
                    t_v = t_vp;
            }
            t_D[t_max+1][t_index] = t_v;
            if (!t_v)
                return (t_k+1);
        }
    }
    return allowed_errors+1;
}
